Subject: Re: wireless vs. alignment requirements

From: Stephen Hemminger <shemminger-de/[email-masked]>
Date: Sun, 25 Nov 2007 13:21:44 -0800

Herbert Xu wrote:
> On Sat, Nov 24, 2007 at 12:11:08PM -0800, Stephen Hemminger wrote:
>   
>> Then what about hardware that can't dma ethernet to non-aligned address.
>> Sky2 hardware breaks if DMA is not 8 byte aligned.  IMHO the IP stack should
>> handle any alignment, and do the appropriate memove if the CPU requires 
>> alignment.
>>     
>
> Luckily all sky2 users have been on x86 so far :)
>
> Here's an idea.  Put the data of the packet into the page frags
> where alignment is not an issue but copy the header so that it
> is aligned.
>
> Would that work?
>
> Cheers,
>   
No too wasteful. I'm working a patch to eth_type_trans to realign if 
needed for any device.